commit 96458d777c1826e20f6d5f082eb9928fcd7f1eb7
Author: freddy77 <freddy77>
Date:   Thu Oct 23 15:09:29 2008 +0000

    improve some conversions from SQL_C_WCHAR

diff --git a/ChangeLog b/ChangeLog
index c32bd01..733fe6a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Oct 23 17:09:26 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/sql2tds.c src/odbc/unittests/genparams.c:
+	- improve some conversions from SQL_C_WCHAR
+
 Thu Oct 23 17:05:03 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* TODO.freddy: updates
 	* include/tdsodbc.h src/odbc/convert_tds2sql.c:
@@ -762,4 +766,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2636 2008/10/23 15:07:48 freddy77 Exp $
+$Id: ChangeLog,v 1.2637 2008/10/23 15:09:29 freddy77 Exp $
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 53ade07..e48ad3a 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -47,12 +47,13 @@
 
 #include "tdsodbc.h"
 #include "tdsconvert.h"
+#include "tdsiconv.h"
 
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.75 2008/09/11 15:09:50 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.76 2008/10/23 15:09:29 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -156,8 +157,23 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		return SQL_ERROR;
 	tdsdump_log(TDS_DBG_INFO2, "trace\n");
 
+	/* get C type */
+	sql_src_type = drec_apd->sql_desc_concise_type;
+	if (sql_src_type == SQL_C_DEFAULT)
+		sql_src_type = odbc_sql_to_c_type_default(drec_ipd->sql_desc_concise_type);
+
 	/* TODO what happen for unicode types ?? */
-	tds_set_param_type(dbc->tds_socket, curcol, dest_type);
+	if (is_char_type(dest_type) && sql_src_type == SQL_C_WCHAR) {
+		TDSSOCKET *tds = dbc->tds_socket;
+		TDSICONV *conv = tds->char_convs[is_unicode_type(dest_type) ? client2ucs2 : client2server_chardata];
+
+		tds_set_column_type(tds, curcol, dest_type);
+
+                curcol->char_conv = tds_iconv_get(tds, ODBC_WIDE_NAME, conv->server_charset.name);
+		memcpy(curcol->column_collation, tds->collation, sizeof(tds->collation));
+	} else {
+		tds_set_param_type(dbc->tds_socket, curcol, dest_type);
+	}
 	if (is_numeric_type(curcol->column_type)) {
 		curcol->column_prec = drec_ipd->sql_desc_precision;
 		curcol->column_scale = drec_ipd->sql_desc_scale;
@@ -193,11 +209,6 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		tds_set_param_type(dbc->tds_socket, curcol, tds_get_null_type(dest_type));
 	}
 
-	/* get C type */
-	sql_src_type = drec_apd->sql_desc_concise_type;
-	if (sql_src_type == SQL_C_DEFAULT)
-		sql_src_type = odbc_sql_to_c_type_default(drec_ipd->sql_desc_concise_type);
-
 	/* test source type */
 	/* TODO test intervals */
 	src_type = odbc_c_to_server_type(sql_src_type);
@@ -298,6 +309,25 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		}
 	}
 
+	switch (dest_type) {
+	case SYBCHAR:
+	case SYBVARCHAR:
+	case XSYBCHAR:
+	case XSYBVARCHAR:
+	case XSYBNVARCHAR:
+	case XSYBNCHAR:
+	case SYBNVARCHAR:
+		if (!need_data && is_char_type(src_type)) {
+			if (curcol->column_data && curcol->column_data_free)
+				curcol->column_data_free(curcol);
+			curcol->column_data_free = NULL;
+			curcol->column_data = (TDS_UCHAR*) src;
+			curcol->column_size = len;
+			curcol->column_cur_size = len;
+			return SQL_SUCCESS;
+		}
+	}
+
 	/* allocate given space */
 	if (!tds_alloc_param_data(curcol)) {
 		odbc_errs_add(&stmt->errs, "HY001", NULL);
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index 194d321..e5580f0 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -4,7 +4,7 @@
 
 /* Test various type from odbc and to odbc */
 
-static char software_version[] = "$Id: genparams.c,v 1.31 2008/10/17 08:06:23 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.32 2008/10/23 15:09:29 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -278,7 +278,8 @@ AllTests(void)
 	TestInput(SQL_C_DOUBLE, "MONEY", SQL_DOUBLE, "MONEY", "123.34");
 
 	TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_VARCHAR, "VARCHAR(20)", "1EasyTest");
-	/* TODO use collate in sintax if available */
+	TestInput(SQL_C_WCHAR, "VARCHAR(10)", SQL_VARCHAR, "VARCHAR(10)", "Test 12345");
+	/* TODO use collate in syntax if available */
 	TestInput(SQL_C_CHAR, "VARCHAR(20)", SQL_VARCHAR, "VARCHAR(20)", "me\xf4");
 
 	precision = 6;
@@ -307,6 +308,9 @@ AllTests(void)
 		Test("NVARCHAR(20)", "foo test", SQL_C_CHAR, SQL_WVARCHAR, "8 foo test");
 		/* TODO use collate in sintax if available */
 		Test("NVARCHAR(20)", "0xf800f900", SQL_C_CHAR, SQL_WVARCHAR, "2 \xf8\xf9");
+
+		TestInput(SQL_C_WCHAR, "NVARCHAR(10)", SQL_WVARCHAR, "NVARCHAR(10)", "1EasyTest2");
+		TestInput(SQL_C_WCHAR, "NVARCHAR(3)", SQL_WVARCHAR, "NVARCHAR(3)", "0xf800a300bc06");
 	}
 }
 

